#!/usr/bin/env python3

import numpy as np
import scipy.optimize
import matplotlib.pyplot as plt


def nicer_fsolve(F, initial_guess):
    """Wrapper for `scipy.optimize.fsolve`.

    This wrapper is used to solve non-linear equations of multidimensial arrays.
    """
    shape = initial_guess.shape

    initial_guess = initial_guess.reshape((-1,))
    result = scipy.optimize.fsolve(
        lambda x: F(x.reshape(shape)).reshape((-1)), initial_guess
    )

    return result.reshape(shape)



# TODO vervollständigen Sie das Template.



def plot_experiment(t, y, label):
    """Plot the numerical experiment.

    Arguments:
        t : 1d-array of time points.
        y : 1d-array of the approximation at `t`.
        label : a string representing the method (preferably alphanumeric).
    """
    plt.figure()
    plt.plot(t, y_exact(t), "r", label="Exact")
    plt.plot(t, y[0, :], "b", label=label)
    plt.grid(True)
    plt.xlabel("t")
    plt.ylabel("y(t)")
    plt.legend(loc="best")
    plt.savefig(label + ".png")



# TODO vervollständigen Sie das Template.

