import scipy.optimize
import numpy as np


def nicer_fsolve(F, initial_guess):
    """Wrapper for `scipy.optimize.fsolve`.

    This wrapper is used to solve non-linear equations of multidimensial arrays.
    """
    shape = initial_guess.shape

    initial_guess = initial_guess.reshape((-1,))
    result = scipy.optimize.fsolve(
        lambda x: F(x.reshape(shape)).reshape((-1)), initial_guess
    )

    return result.reshape(shape)



# TODO vervollständigen Sie das Template.

